(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@rx-angular/cdk'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@rx-angular/template', ['exports', '@angular/core', 'rxjs', '@rx-angular/cdk', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['rx-angular'] = global['rx-angular'] || {}, global['rx-angular'].template = {}), global.ng.core, global.rxjs, global['rx-angular'].cdk, global.rxjs.operators));
}(this, (function (exports, core, rxjs, cdk, operators) { 'use strict';

    var zonePatchedEvents = [
        'scroll',
        'mousedown',
        'mouseenter',
        'mouseleave',
        'mousemove',
        'mouseout',
        'mouseover',
        'mouseup',
        'load',
        'pointerup',
        'change',
        'blur',
        'focus',
        'click',
        'contextmenu',
        'drag',
        'dragend',
        'dragenter',
        'dragleave',
        'dragover',
        'dragstart',
        'drop',
        'input'
    ];

    /**
     * @description
     *
     * A fallback for the new `globalThis` reference.
     *
     *  It should be used to replace `window` due to different environments in:
     *  - SSR (Server Side Rendering)
     *  - Tests
     *  - Browser
     *
     *  @return {globalThis} - A reference to globalThis. `window` in the Browser.
     */
    function getGlobalThis() {
        return core.ɵglobal;
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /*
     * createPropertiesWeakMap
     *
     * @param getDefaults: (o: O) => P
     * Example:
     *
     * export interface Properties {
     *   isCoalescing: boolean;
     * }
     *
     * const obj: object = {
     *   foo: 'bar',
     *   isCoalescing: 'weakMap version'
     * };
     *
     * const getDefaults = (ctx: object): Properties => ({isCoalescing: false});
     * const propsMap = createPropertiesWeakMap<object, Properties>(getDefaults);
     *
     * console.log('obj before:', obj);
     * // {foo: "bar", isCoalescing: "weakMap version"}
     * console.log('props before:', propsMap.getProps(obj));
     * // {isCoalescing: "weakMap version"}
     *
     * propsMap.setProps(obj, {isCoalescing: true});
     * console.log('obj after:', obj);
     * // {foo: "bar", isCoalescing: "weakMap version"}
     * console.log('props after:', propsMap.getProps(obj));
     * // {isCoalescing: "true"}
     * */
    function createPropertiesWeakMap(getDefaults) {
        var propertyMap = new WeakMap();
        return {
            getProps: getProperties,
            setProps: setProperties
        };
        function getProperties(ctx) {
            var defaults = getDefaults(ctx);
            var propertiesPresent = propertyMap.get(ctx);
            var properties;
            if (propertiesPresent !== undefined) {
                properties = propertiesPresent;
            }
            else {
                properties = {};
                Object.entries(defaults).forEach(function (_a) {
                    var _b = __read(_a, 2), prop = _b[0], value = _b[1];
                    properties[prop] = hasKey(ctx, prop) ? ctx[prop] : value;
                });
                propertyMap.set(ctx, properties);
            }
            return properties;
        }
        function setProperties(ctx, props) {
            var properties = getProperties(ctx);
            Object.entries(props).forEach(function (_a) {
                var _b = __read(_a, 2), prop = _b[0], value = _b[1];
                properties[prop] = value;
            });
            propertyMap.set(ctx, properties);
            return properties;
        }
        function hasKey(ctx, property) {
            return ctx[property] != null;
        }
    }

    /**
     * getZoneUnPatchedApi
     *
     * @description
     *
     * This function returns the zone un-patched API for the a specific Browser API.
     * If no element is passed the window is used instead
     *
     * @param name {string} - The name of the API to check.
     * @param elem {any} - The elem to get un-patched API from.
     * @return {Function} - The zone un-patched API in question.
     *
     */
    function getZoneUnPatchedApi(name, elem) {
        elem = elem || getGlobalThis();
        return isApiZonePatched(name, elem) ? elem['__zone_symbol__' + name] : elem[name];
    }
    /**
     * envZonePatched
     *
     * @description
     *
     * This function checks the window object `zone.js` was instantiated.
     * If so, the `window` object maintains a property named `Zone`.
     *
     * Here how Angular checks it: https://github.com/angular/angular/blob/master/packages/core/src/zone/ng_zone.ts#L123
     *
     * @return {boolean} - true if `zone.js` patched global APIs.
     *
     */
    function isEnvZonePatched() {
        return getGlobalThis().Zone !== undefined;
    }
    /**
     * apiZonePatched
     *
     * @description
     *
     * This function checks if a specific Browser API is patched by `zone.js`.
     *
     * @param name - The name of the API to check.
     * @param elem - The name of the API to check.
     * @return {boolean} - true if `zone.js` patched the API in question.
     *
     */
    function isApiZonePatched(name, elem) {
        // if symbol is present, zone patched the API
        return elem['__zone_symbol__' + name] !== undefined;
    }
    var zoneDetectionCache = new WeakMap();
    /**
     * isNgZone
     *
     * @description
     *
     * This function takes an instance of a class which implements the NgZone interface and checks if
     * its `runOutsideAngular()` function calls `apply()` on the function passed as parameter. This
     * means the Angular application that instantiated this service assumes it runs in a ZoneLess
     * environment, and therefore it's change detection will not be triggered by zone related logic.
     *
     * However, keep in mind this does not mean `zone.js` is not present.
     * The environment could still run in ZoneFull mode even if Angular turned it off.
     * Consider the situation of a Angular element configured for ZoneLess
     * environments is used in an Angular application relining on the zone mechanism.
     *
     * @param instance {Class Instance} - The instance to check for constructor name of `NgZone`.
     * @return {boolean} - true if instance is of type `NgZone`.
     *
     */
    function isNgZone(instance) {
        var cachedValue = zoneDetectionCache.get(instance);
        if (cachedValue !== undefined) {
            return cachedValue;
        }
        var calledApply = false;
        function fn() {
        }
        fn.apply = function () { return (calledApply = true); };
        instance.runOutsideAngular(fn);
        zoneDetectionCache.set(instance, calledApply);
        return calledApply;
    }
    /**
     * isNoopNgZone
     *
     *@description
     *
     * This function takes any instance of a class and checks
     * if the constructor name is equal to `NoopNgZone`.
     *
     * For more detailed information read the description of [isNgZone](#isngzone).
     *
     * @param instance {Class Instance} - The instance to check for constructor name of `NoopNgZone`.
     * @return {boolean} - true if instance is of type `NoopNgZone`.
     *
     */
    function isNoopNgZone(instance) {
        return !isNgZone(instance);
    }

    /** A shared promise instance to cause a delay of one microtask */
    var resolvedPromise = null;
    function getUnpatchedResolvedPromise() {
        resolvedPromise = resolvedPromise || getZoneUnPatchedApi('Promise').resolve();
        return resolvedPromise;
    }

    var coalescingManager = createCoalesceManager();
    var ɵ0$1 = function (ctx) { return ({
        numCoalescingSubscribers: 0
    }); };
    var coalescingContextPropertiesMap = createPropertiesWeakMap(ɵ0$1);
    /**
     * @describe createCoalesceManager
     *
     * returns a
     * Maintains a weak map of component references ans flags
     * them if the coalescing process is already started for them.
     *
     * Used in render aware internally.
     */
    function createCoalesceManager() {
        return {
            remove: removeWork,
            add: addWork,
            isCoalescing: isCoalescing
        };
        // Increments the number of subscriptions in a scope e.g. a class instance
        function removeWork(scope) {
            var numCoalescingSubscribers = coalescingContextPropertiesMap.getProps(scope).numCoalescingSubscribers - 1;
            coalescingContextPropertiesMap.setProps(scope, {
                numCoalescingSubscribers: numCoalescingSubscribers >= 0 ? numCoalescingSubscribers : 0
            });
        }
        // Decrements the number of subscriptions in a scope e.g. a class instance
        function addWork(scope) {
            var numCoalescingSubscribers = coalescingContextPropertiesMap.getProps(scope).numCoalescingSubscribers +
                1;
            coalescingContextPropertiesMap.setProps(scope, {
                numCoalescingSubscribers: numCoalescingSubscribers
            });
        }
        // Checks if anybody else is already coalescing atm
        function isCoalescing(scope) {
            return (coalescingContextPropertiesMap.getProps(scope).numCoalescingSubscribers >
                0);
        }
    }

    /**
     *
     * @description
     *
     * This function takes an elem and event and re-applies the listeners from the passed event to the
     * passed element with the zone un-patched version of it.
     *
     * @param elem {HTMLElement} - The elem to re-apply the listeners to.
     * @param event {string} - The name of the event from which to re-apply the listeners.
     *
     * @returns void
     */
    function unpatchEventListener$1(element, event) {
        // `EventTarget` is patched only in the browser environment, thus
        // running this code on the server-side will throw an exception:
        // `TypeError: element.eventListeners is not a function`.
        if (typeof element.eventListeners !== 'function') {
            return;
        }
        var eventListeners = element.eventListeners(event);
        // Return if no event listeners are present
        if (!eventListeners) {
            return;
        }
        var addEventListener = getZoneUnPatchedApi('addEventListener', element).bind(element);
        eventListeners.forEach(function (listener) {
            // Remove and reapply listeners with patched API
            // @TODO use (elem as any).removeAllListeners?(eventName?: string): void;
            element.removeEventListener(event, listener);
            // Reapply listeners with un-patched API
            addEventListener(event, listener);
        });
    }
    /**
     * @Directive UnpatchEventsDirective
     *
     * @description
     *
     * The `unpatch` directive helps in partially migrating to zone-less apps as well as getting rid
     * of unnecessary renderings through zones `addEventListener` patches.
     * It can be used on any element you apply event bindings.
     *
     * The current way of binding events to the DOM is to use output bindings:
     *  ```html
     * <button (click)="doStuff($event)">click me</button>
     * ```
     *
     * The problem is that every event registered over `()` syntax, e.g. `(click)`
     * marks the component and all its ancestors as dirty and re-renders the whole component tree.
     * This is because zone.js patches the native browser API and whenever one of the patched APIs is used it re-renders.
     *
     * So even if your button is not related to a change that needs a re-render the app will re-render completely.
     * This leads to bad performance. This is especially helpful if you work with frequently fired events like 'mousemove'
     *
     * `unpatch` directive solves that problem.
     *
     * Included Features:
     *  - by default un-patch all registered listeners of the host it is applied on
     *  - un-patch only a specified set of registered event listeners
     *  - works zone independent (it directly checks the widow for patched APIs and un-patches them without the use of `runOutsideZone` which brings more performance)
     *  - Not interfering with any logic executed by the registered callback
     *
     * @usageNotes
     *
     * The `unpatch` directive can be used like shown here:
     * ```html
     * <button [unpatch] (click)="triggerSomeMethod($event)">click me</button>
     * <button [unpatch]="['mousemove']" (mousemove)="doStuff2($event)" (click)="doStuff($event)">click me</button>
     * ```
     *
     * @publicApi
     */
    // tslint:disable-next-line:directive-selector
    var UnpatchEventsDirective = /** @class */ (function () {
        function UnpatchEventsDirective(el) {
            this.el = el;
            this.subscription = new rxjs.Subscription();
            this.events$ = new rxjs.BehaviorSubject(zonePatchedEvents);
        }
        UnpatchEventsDirective.prototype.reapplyEventListenersZoneUnPatched = function (events) {
            var _this = this;
            events.forEach(function (ev) {
                unpatchEventListener$1(_this.el.nativeElement, ev);
            });
        };
        UnpatchEventsDirective.prototype.ngOnChanges = function (_a) {
            var events = _a.events;
            if (events && Array.isArray(this.events)) {
                this.events$.next(this.events);
            }
        };
        UnpatchEventsDirective.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.subscription = this.events$.subscribe(function (eventList) {
                _this.reapplyEventListenersZoneUnPatched(eventList);
            });
        };
        UnpatchEventsDirective.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        return UnpatchEventsDirective;
    }());
    UnpatchEventsDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[unpatch]' },] }
    ];
    /** @nocollapse */
    UnpatchEventsDirective.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    UnpatchEventsDirective.propDecorators = {
        events: [{ type: core.Input, args: ['unpatch',] }]
    };

    var DECLARATIONS$2 = [UnpatchEventsDirective];
    var UnpatchEventsModule = /** @class */ (function () {
        function UnpatchEventsModule() {
        }
        return UnpatchEventsModule;
    }());
    UnpatchEventsModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: DECLARATIONS$2,
                    exports: DECLARATIONS$2
                },] }
    ];

    function rxMaterialize() {
        return function (o$) { return o$.pipe(operators.materialize(), operators.tap(function (_a) {
            var kind = _a.kind, error = _a.error;
            if (kind === 'E') {
                console.error(error);
            }
        }), operators.map(function (_a) {
            var value = _a.value, hasValue = _a.hasValue, error = _a.error, kind = _a.kind;
            return ({
                value: value,
                hasValue: hasValue,
                error: error,
                kind: notificationKindToRxNotificationKind(kind)
            });
        })); };
    }
    function notificationKindToRxNotificationKind(kind) {
        switch (kind) {
            case 'C':
                return 'rxComplete';
            case 'E':
                return 'rxError';
            case 'N':
            default:
                return 'rxNext';
        }
    }

    /**
     * RenderAware
     *
     * @description
     * This function returns an object that holds all the shared logic for the push pipe and the let directive
     * responsible for change detection
     * If you extend this class you need to implement how the update of the rendered value happens.
     * Also custom behaviour is something you need to implement in the extending class
     */
    function createRenderAware(cfg) {
        var strategyName$ = new rxjs.ReplaySubject(1);
        var currentStrategy;
        var strategy$ = strategyName$.pipe(operators.distinctUntilChanged(), operators.switchMap(function (stringOrObservable) { return typeof stringOrObservable === 'string'
            ? rxjs.of(stringOrObservable)
            : stringOrObservable; }), operators.map(function (strategy) {
            var s = cfg.strategies[strategy];
            if (!!s) {
                return s;
            }
            throw new Error("Strategy " + strategy + " does not exist.");
        }), operators.tap(function (s) { return (currentStrategy = s); }), 
        // do not repeat the steps before for each subscriber
        operators.shareReplay({ bufferSize: 1, refCount: true }));
        var observablesFromTemplate$ = new rxjs.ReplaySubject(1);
        var valuesFromTemplate$ = observablesFromTemplate$.pipe(operators.distinctUntilChanged());
        var firstTemplateObservableChange = true;
        var renderingEffect$ = valuesFromTemplate$.pipe(
        // handle null | undefined assignment and new Observable reset
        operators.map(function (observable$) {
            if (observable$ === null) {
                return rxjs.of(null);
            }
            if (!firstTemplateObservableChange) {
                cfg.templateObserver.suspense();
                if (observable$ === undefined) {
                    return rxjs.of(undefined);
                }
            }
            firstTemplateObservableChange = false;
            return observable$;
        }), 
        // forward only observable values
        operators.filter(function (o$) { return o$ !== undefined; }), operators.distinctUntilChanged(), operators.switchMap(function (o$) { return o$
            // Added behavior will get applied to the observable in `renderWithLatestStrategy`
            .pipe(
        // Forward only distinct values
        operators.distinctUntilChanged(), 
        // Update completion, error and next
        operators.tap(cfg.templateObserver), renderWithLatestStrategy(strategy$)); }), operators.publish());
        return {
            nextPotentialObservable: function (value) {
                observablesFromTemplate$.next(value);
            },
            nextStrategy: function (nextConfig) {
                strategyName$.next(nextConfig);
            },
            rendered$: renderingEffect$,
            activeStrategy$: strategy$,
            subscribe: function () {
                return new rxjs.Subscription().add(renderingEffect$.connect());
            }
        };
    }
    function renderWithLatestStrategy(strategyChanges$) {
        var suspenseNotification = {
            kind: 'rxSuspense',
            value: undefined,
            hasValue: false,
            error: undefined,
        };
        return function (o$) {
            return o$.pipe(rxMaterialize(), operators.withLatestFrom(strategyChanges$), 
            // always use latest strategy on value change
            operators.switchMap(function (_a) {
                var _b = __read(_a, 2), renderValue = _b[0], strategy = _b[1];
                return rxjs.concat(rxjs.of(renderValue), rxjs.NEVER).pipe(strategy.rxScheduleCD);
            }), operators.startWith(suspenseNotification));
        };
    }

    /** @internal */
    var RxLetTemplateNames = Object.assign(Object.assign({}, cdk.RxBaseTemplateNames), { next: 'nextTpl' });
    /**
     * @Directive LetDirective
     *
     * @description
     *
     * The `*rxLet` directive serves a convenient way of binding observables to a view context. Furthermore, it helps
     * you structure view-related models into view context scope (DOM element's scope).
     *
     * Under the hood, it leverages a `RenderStrategy` which in turn takes care of optimizing the change detection
     * of your component or embedded view. The `LetDirective` will render its template and manage change detection after it
     *   got an initial value. So if the incoming `Observable` emits its value lazily (e.g. data coming from `Http`), your
     *   template will be rendered lazily as well. This can very positively impact the initial render performance of your
     *   application.
     *
     *
     * ### Problems with `async` and `*ngIf`
     *
     * In Angular, a way of binding an observable to the view could look like that:
     * ```html
     * <ng-container *ngIf="observableNumber$ | async as n">
     *   <app-number [number]="n"></app-number>
     *   <app-number-special [number]="n"></app-number-special>
     * </ng-container>
     * ```
     *
     * The problem is that `*ngIf` interferes with rendering and in case of a `0` (a falsy value) the component
     * would be hidden. This issue doesn't concern the `LetDirective`.
     *
     * The `AsyncPipe` relies on the Zone to be present - it doesn't really trigger change detection by itself.
     * It marks the component and its children as dirty waiting for the Zone to trigger change detection. So, in case
     * you want to create a zone-less application, the `AsyncPipe` won't work as desired. `LetDirective` comes
     * with its own strategies to manage change detection every time a new notification is sent from
     * the bound Observable.
     *
     *
     * ### Features of `*rxLet`
     *
     * Included features for `*rxLet`:
     * - binding is always present. (see "Problems with `async` and `*ngIf`" section below)
     * - it takes away the multiple usages of the `async` or `push` pipe
     * - a unified/structured way of handling null and undefined
     * - triggers change-detection differently if `zone.js` is present or not (`ChangeDetectorRef.detectChanges` or
     *   `ChangeDetectorRef.markForCheck`)
     * - triggers change-detection differently if ViewEngine or Ivy is present (`ChangeDetectorRef.detectChanges` or
     *   `ɵdetectChanges`)
     * - distinct same values in a row (`distinctUntilChanged` operator),
     * - display custom templates for different observable notifications (rxSuspense, rxNext, rxError, rxComplete)
     * - notify about after changes got rendered to the template (RenderCallback)
     *
     *
     * ### Binding an Observable and using the view context
     *
     * The `*rxLet` directive takes over several things and makes it more convenient and save to work with streams in the
     * template:
     *
     * ```html
     * <ng-container *rxLet="observableNumber$; let n">
     *   <app-number [number]="n"></app-number>
     * </ng-container>
     *
     * <ng-container *rxLet="observableNumber$ as n">
     *   <app-number [number]="n"></app-number>
     * </ng-container>
     * ```
     *
     * In addition to that it provides us information from the whole observable context.
     * We can track the observables:
     * - next value
     * - error occurrence
     * - complete occurrence
     *
     * ```html
     * <ng-container *rxLet="observableNumber$; let n; let e = $rxError, let c = $rxComplete">
     *   <app-number [number]="n" *ngIf="!e && !c"></app-number>
     *   <ng-container *ngIf="e">
     *     There is an error: {{ e }}
     *   </ng-container>
     *   <ng-container *ngIf="c">
     *     Observable completed: {{ c }}
     *   </ng-container>
     * </ng-container>
     * ```
     *
     *
     * ### Using the template-binding
     *
     * You can also use template anchors and display template's content for different observable states:
     * - on complete
     * - on error
     * - on suspense - before the first value is emitted
     *
     * ```html
     * <ng-container
     *   *rxLet="
     *     observableNumber$;
     *     let n;
     *     rxError: error;
     *     rxComplete: complete;
     *     rxSuspense: suspense;
     *   "
     * >
     *   <app-number [number]="n"></app-number>
     * </ng-container>
     * <ng-template #error>ERROR</ng-template>
     * <ng-template #complete>COMPLETE</ng-template>
     * <ng-template #suspense>SUSPENSE</ng-template>
     * ```
     *
     * Internally, `*rxLet` is using a simple "view memoization" - it caches all anchored template references and re-uses
     * them whenever the observable notification (next/error/complete) is sent. Then, it only updates the context
     * (e.g. a value from the observable) in the view.
     *
     *
     * @docsCategory LetDirective
     * @docsPage LetDirective
     * @publicApi
     */
    var LetDirective = /** @class */ (function () {
        // TODO: enable when tested and documented properly
        /* @Input('rxLetShowComplete')
         set showComplete(trigger$: Observable<any>) {
         this.triggerHandler.next(
         trigger$.pipe(mapTo(toRxCompleteNotification() as any))
         );
         }
      
         @Input('rxLetShowError')
         set showError(error$: Observable<any>) {
         this.triggerHandler.next(error$.pipe(map(toRxErrorNotification as any)));
         }
      
         @Input('rxLetShowSuspense')
         set showSuspense(trigger$: Observable<any>) {
         this.triggerHandler.next(
         trigger$.pipe(map(toRxSuspenseNotification as any))
         );
         }*/
        function LetDirective(strategyProvider, cdRef, eRef, ngZone, nextTemplateRef, viewContainerRef) {
            var _this = this;
            this.strategyProvider = strategyProvider;
            this.cdRef = cdRef;
            this.eRef = eRef;
            this.ngZone = ngZone;
            this.nextTemplateRef = nextTemplateRef;
            this.viewContainerRef = viewContainerRef;
            this.renderParent = true;
            this.patchZone = this.strategyProvider.config.patchZone;
            /** @internal */
            this.observablesHandler = cdk.templateNotifier(function () { return !!_this.rxSuspense; });
            /** @internal */
            this.strategyHandler = cdk.hotFlatten(function () { return new rxjs.ReplaySubject(1); });
            /** @internal */
            this.triggerHandler = cdk.hotFlatten(function () { return new rxjs.Subject(); }, operators.mergeAll());
            /** @internal */
            this.subscription = new rxjs.Subscription();
            /** @internal */
            this.rendered$ = new rxjs.Subject();
            this.rendered = rxjs.defer(function () { return _this.rendered$.pipe(); });
        }
        Object.defineProperty(LetDirective.prototype, "rxLet", {
            /**
             * @description
             * The Observable to be bound to the context of a template.
             *
             * @example
             * <ng-container *rxLet="hero$; let hero">
             *   <app-hero [hero]="hero"></app-hero>
             * </ng-container>
             *
             * @param potentialObservable
             */
            set: function (potentialObservable) {
                this.observablesHandler.next(potentialObservable);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LetDirective.prototype, "strategy", {
            /**
             * @description
             * The rendering strategy to be used when rendering with the reactive context within a template.
             * Use it to dynamically manage your rendering strategy. You can switch the strategies
             * imperatively (with a string) or by bounding an Observable.
             * The default strategy is `'local'`.
             *
             * @example
             * \@Component({
             *   selector: 'app-root',
             *   template: `
             *     <ng-container *rxLet="hero$; let hero; strategy: strategy">
             *       <app-hero [hero]="hero"></app-hero>
             *     </ng-container>
             *   `
             * })
             * export class AppComponent {
             *   strategy = 'local';
             * }
             *
             * // OR
             *
             * \@Component({
             *   selector: 'app-root',
             *   template: `
             *     <ng-container *rxLet="hero$; let hero; strategy: strategy$">
             *       <app-hero [hero]="hero"></app-hero>
             *     </ng-container>
             *   `
             * })
             * export class AppComponent {
             *   strategy$ = new BehaviorSubject('local');
             * }
             *
             * @param strategy
             * @see {@link strategies}
             */
            set: function (strategyName) {
                this.strategyHandler.next(strategyName);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(LetDirective.prototype, "renderCallback", {
            set: function (callback) {
                this._renderObserver = callback;
            },
            enumerable: false,
            configurable: true
        });
        /** @internal */
        LetDirective.ngTemplateContextGuard = function (dir, ctx) {
            return true;
        };
        /** @internal */
        LetDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription.add(this.templateManager
                .render(this.observablesHandler.values$)
                .subscribe(function (n) {
                var _a;
                _this.rendered$.next(n);
                (_a = _this._renderObserver) === null || _a === void 0 ? void 0 : _a.next(n);
            }));
        };
        /** @internal */
        LetDirective.prototype.ngOnChanges = function (changes) {
            if (!this.templateManager) {
                this._createTemplateManager();
            }
            if (changes.rxComplete) {
                this.templateManager.addTemplateRef(RxLetTemplateNames.complete, this.rxComplete);
            }
            if (changes.rxSuspense) {
                this.templateManager.addTemplateRef(RxLetTemplateNames.suspense, this.rxSuspense);
            }
            if (changes.rxError) {
                this.templateManager.addTemplateRef(RxLetTemplateNames.error, this.rxError);
            }
        };
        /** @internal */
        LetDirective.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        /** @internal */
        LetDirective.prototype._createTemplateManager = function () {
            var _b;
            var _this = this;
            this.templateManager = cdk.createTemplateManager({
                templateSettings: {
                    viewContainerRef: this.viewContainerRef,
                    createViewContext: createViewContext,
                    updateViewContext: updateViewContext,
                    customContext: function (rxLet) { return ({ rxLet: rxLet }); },
                    patchZone: this.patchZone ? this.ngZone : false,
                },
                renderSettings: {
                    cdRef: this.cdRef,
                    eRef: this.eRef,
                    parent: !!this.renderParent,
                    patchZone: this.patchZone ? this.ngZone : false,
                    defaultStrategyName: this.strategyProvider.primaryStrategy,
                    strategies: this.strategyProvider.strategies,
                },
                notificationToTemplateName: (_b = {},
                    _b[cdk.RxNotificationKind.suspense] = function () { return _this.rxSuspense
                        ? RxLetTemplateNames.suspense
                        : RxLetTemplateNames.next; },
                    _b[cdk.RxNotificationKind.next] = function () { return RxLetTemplateNames.next; },
                    _b[cdk.RxNotificationKind.error] = function () { return _this.rxError ? RxLetTemplateNames.error : RxLetTemplateNames.next; },
                    _b[cdk.RxNotificationKind.complete] = function () { return _this.rxComplete
                        ? RxLetTemplateNames.complete
                        : RxLetTemplateNames.next; },
                    _b),
                templateTrigger$: this.triggerHandler.values$,
            });
            this.templateManager.addTemplateRef(RxLetTemplateNames.next, this.nextTemplateRef);
            this.templateManager.nextStrategy(this.strategyHandler.values$);
        };
        return LetDirective;
    }());
    LetDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[rxLet]',
                    providers: [],
                },] }
    ];
    /** @nocollapse */
    LetDirective.ctorParameters = function () { return [
        { type: cdk.RxStrategyProvider },
        { type: core.ChangeDetectorRef },
        { type: core.ElementRef },
        { type: core.NgZone },
        { type: core.TemplateRef },
        { type: core.ViewContainerRef }
    ]; };
    LetDirective.propDecorators = {
        rxLet: [{ type: core.Input }],
        strategy: [{ type: core.Input, args: ['rxLetStrategy',] }],
        rxComplete: [{ type: core.Input, args: ['rxLetRxComplete',] }],
        rxError: [{ type: core.Input, args: ['rxLetRxError',] }],
        rxSuspense: [{ type: core.Input, args: ['rxLetRxSuspense',] }],
        renderCallback: [{ type: core.Input, args: ['rxLetRenderCallback',] }],
        renderParent: [{ type: core.Input, args: ['rxLetParent',] }],
        patchZone: [{ type: core.Input, args: ['rxLetPatchZone',] }],
        rendered: [{ type: core.Output }]
    };
    /** @internal */
    function createViewContext(value) {
        return {
            rxLet: value,
            $implicit: value,
            $error: false,
            $complete: false,
            $suspense: false,
        };
    }
    /** @internal */
    function updateViewContext(value, view, context) {
        Object.keys(context).forEach(function (k) {
            view.context[k] = context[k];
        });
    }

    /**
     *
     * @description
     *
     * This function takes an elem and event and re-applies the listeners from the passed event to the
     * passed element with the zone un-patched version of it.
     *
     * @param elem {HTMLElement} - The elem to re-apply the listeners to.
     * @param event {string} - The name of the event from which to re-apply the listeners.
     *
     * @returns void
     */
    function unpatchEventListener(elem, event) {
        var eventListeners = elem.eventListeners(event);
        // Return if no event listeners are present
        if (!eventListeners) {
            return;
        }
        var addEventListener = getZoneUnPatchedApi('addEventListener', elem).bind(elem);
        eventListeners.forEach(function (listener) {
            // Remove and reapply listeners with patched API
            elem.removeEventListener(event, listener);
            // Reapply listeners with un-patched API
            addEventListener(event, listener);
        });
    }
    function intersectionObserver(options) {
        var subject = new rxjs.Subject();
        var observer = observerSupported()
            ? new IntersectionObserver(function (entries) {
                entries.forEach(function (entry) { return subject.next(entry); });
            }, options)
            : null;
        var entries$ = new rxjs.Observable(function (subscriber) {
            subject.subscribe(subscriber);
            return function () {
                if (observer) {
                    observer.disconnect();
                }
            };
        });
        return {
            entries$: entries$,
            observe: observer.observe,
            unobserve: observer.unobserve,
        };
    }
    var observerSupported = function () { return typeof window !== 'undefined'
        ? !!window.IntersectionObserver
        : false; };
    var ɵ0 = observerSupported;
    var ViewportPrioDirective = /** @class */ (function () {
        function ViewportPrioDirective(el, strategyProvider, letDirective) {
            var _this = this;
            this.el = el;
            this.strategyProvider = strategyProvider;
            this.letDirective = letDirective;
            // Note that we're picking only the `intersectionRatio` property
            // since this is the only property that we're intersted in.
            this.entriesSubject = new rxjs.Subject();
            this.entries$ = this.entriesSubject.pipe(operators.mergeAll());
            this._viewportPrio = 'noop';
            /* @Input('viewport-prio')
            set viewportPrio(prio) {
              if (prio) {
                this._viewportPrio = prio || 'noop';
              }
            }*/
            this.observer = observerSupported()
                ? new IntersectionObserver(function (entries) {
                    _this.entriesSubject.next(entries);
                }, {
                    threshold: 0,
                })
                : null;
            this.visibilityEvents$ = this.entries$.pipe(operators.map(function (entry) {
                if (entry.intersectionRatio > 0) {
                    return 'visible';
                }
                else {
                    return 'invisible';
                }
            }));
        }
        ViewportPrioDirective.prototype.ngOnInit = function () {
            var _this = this;
            var letStrategyName$ = this.letDirective['strategyHandler'].values$.pipe(operators.filter(function (name) { return name !== _this._viewportPrio; }));
            this.visibilityEvents$
                .pipe(operators.withLatestFrom(letStrategyName$), operators.map(function (_a) {
                var _b = __read(_a, 2), visibility = _b[0], strategyName = _b[1];
                return visibility === 'visible' ? strategyName : _this._viewportPrio;
            }))
                .subscribe(function (strategyName) {
                _this.letDirective.strategy = strategyName;
                // render actual state on viewport enter
                // @TODO this doesnt catch unsubscribe (cant be cancelled)
                // @TODO: we need to fetch the current template of the letDirective here
                // this.strategyProvider.scheduleCD()
            });
            // If the browser doesn't support the `IntersectionObserver` or we're inside
            // the Node.js environment, then this will throw an exception that property
            // `observe` doesn't exist on `null`.
            if (this.observer !== null) {
                this.observer.observe(this.el.nativeElement);
            }
            else {
                // If we're inside the Node.js environment then this should be
                // rendered (e.g. for SEO purposes), and when running this code in browser
                // it will decide itself to render it or not.
                this.entriesSubject.next([{ intersectionRatio: 1 }]);
            }
        };
        ViewportPrioDirective.prototype.ngOnDestroy = function () {
            if (this.observer) {
                this.observer.disconnect();
            }
        };
        return ViewportPrioDirective;
    }());
    ViewportPrioDirective.decorators = [
        { type: core.Directive, args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: '[viewport-prio]',
                },] }
    ];
    /** @nocollapse */
    ViewportPrioDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: cdk.RxStrategyProvider },
        { type: LetDirective, decorators: [{ type: core.Optional }] }
    ]; };

    var DECLARATIONS$1 = [ViewportPrioDirective];
    var ViewportPrioModule = /** @class */ (function () {
        function ViewportPrioModule() {
        }
        return ViewportPrioModule;
    }());
    ViewportPrioModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: DECLARATIONS$1,
                    exports: DECLARATIONS$1
                },] }
    ];

    /**
     * @Pipe PushPipe
     *
     * @description
     *
     * The `push` pipe serves as a drop-in replacement for the `async` pipe.
     * It contains intelligent handling of change detection to enable us
     * running in zone-full as well as zone-less mode without any changes to the code.
     *
     * The current way of binding an observable to the view looks like that:
     *  ```html
     *  {{observable$ | async}}
     * <ng-container *ngIf="observable$ | async as o">{{o}}</ng-container>
     * <component [value]="observable$ | async"></component>
     * ```
     *
     * The problem is `async` pipe just marks the component and all its ancestors as dirty.
     * It needs zone.js microtask queue to exhaust until `ApplicationRef.tick` is called to render all dirty marked
     *     components.
     *
     * Heavy dynamic and interactive UIs suffer from zones change detection a lot and can
     * lean to bad performance or even unusable applications, but the `async` pipe does not work in zone-less mode.
     *
     * `push` pipe solves that problem.
     *
     * Included Features:
     *  - Take observables or promises, retrieve their values and render the value to the template
     *  - Handling null and undefined values in a clean unified/structured way
     *  - Triggers change-detection differently if `zone.js` is present or not (`detectChanges` or `markForCheck`)
     *  - Distinct same values in a row to increase performance
     *  - Coalescing of change detection calls to boost performance
     *
     * @usageNotes
     *
     * `push` pipe solves that problem. It can be used like shown here:
     * ```html
     * {{observable$ | push}}
     * <ng-container *ngIf="observable$ | push as o">{{o}}</ng-container>
     * <component [value]="observable$ | push"></component>
     * ```
     *
     * @publicApi
     */
    var PushPipe = /** @class */ (function () {
        function PushPipe(strategyProvider, cdRef) {
            var _this = this;
            this.strategyProvider = strategyProvider;
            this.cdRef = cdRef;
            /** @internal */
            this.templateObserver = cdk.templateNotifier();
            /** @internal */
            this.strategyHandler = cdk.strategyHandling(this.strategyProvider.primaryStrategy, this.strategyProvider.strategies);
            var scope = cdRef.context;
            this.subscription = this.templateObserver.values$
                .pipe(operators.filter(function (n) { return n.kind === cdk.RxNotificationKind.suspense ||
                n.kind === cdk.RxNotificationKind.next; }), operators.tap(function (notification) {
                _this.renderedValue = notification.value;
            }), operators.withLatestFrom(this.strategyHandler.strategy$), operators.switchMap(function (_a) {
                var _b = __read(_a, 2), v = _b[0], strategy = _b[1];
                return _this.strategyProvider.schedule(function () {
                    strategy.work(cdRef, scope);
                }, {
                    scope: scope,
                    strategy: strategy.name,
                    patchZone: _this.strategyProvider.config.patchZone ? null : false,
                });
            }))
                .subscribe();
        }
        PushPipe.prototype.transform = function (potentialObservable, config, renderCallback) {
            if (config) {
                this.strategyHandler.next(config);
            }
            this.templateObserver.next(potentialObservable);
            return this.renderedValue;
        };
        /** @internal */
        PushPipe.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        return PushPipe;
    }());
    PushPipe.decorators = [
        { type: core.Pipe, args: [{ name: 'push', pure: false },] }
    ];
    /** @nocollapse */
    PushPipe.ctorParameters = function () { return [
        { type: cdk.RxStrategyProvider },
        { type: core.ChangeDetectorRef }
    ]; };

    var DECLARATIONS = [PushPipe];
    /**
     * @description
     * This module exports the PushPipe
     *
     * @example
     *
     * ```typescript
     * @NgModule({
     *  imports: [PushModule],
     *  //...
     * })
     * export class AppModule {}
     * ```
     *
     */
    var PushModule = /** @class */ (function () {
        function PushModule() {
        }
        return PushModule;
    }());
    PushModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: DECLARATIONS,
                    imports: [],
                    exports: DECLARATIONS
                },] }
    ];

    var EXPORTED_DECLARATIONS = [LetDirective];
    var LetModule = /** @class */ (function () {
        function LetModule() {
        }
        return LetModule;
    }());
    LetModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: EXPORTED_DECLARATIONS,
                    exports: [EXPORTED_DECLARATIONS]
                },] }
    ];

    // EXPERIMENTAL

    /**
     * Generated bundle index. Do not edit.
     */

    exports.LetDirective = LetDirective;
    exports.LetModule = LetModule;
    exports.PushModule = PushModule;
    exports.PushPipe = PushPipe;
    exports.UnpatchEventsDirective = UnpatchEventsDirective;
    exports.UnpatchEventsModule = UnpatchEventsModule;
    exports.ViewportPrioDirective = ViewportPrioDirective;
    exports.ViewportPrioModule = ViewportPrioModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=rx-angular-template.umd.js.map
